---
title: JavaScript for PHP Developers
description: Describing the architecture of Handlers, Services, (Domains), and Presentation
date: 2024-12-11
tags:
  - development
  - javascript
  - typescript
  - PHP
draft: true
---


# Writing JavaScript for PHP Developers

I want to write a blog post about how to approach large server-side JavaScript
projects from the perspective of a PHP developer.

I also want to talk about testing and mocking and how things are more like C
than they are like Java in the JavaScript world.

Classes aren't all that important and are more focused on sharing state between
many functions.

Talk about how the module system essentially creates a bunch of Singletons and
how Factory functions are your key to great design.

TypeScript and why `Type`'s are more valuable than `Interface`'s but why Interfaces
are still super important to reason with.
